/*
    Aquaponic IoT Controler
    Copyright (C) 2015  Davor Marjanović <aquaponic.controller@gmail.com>
    Licence: GNU GENERAL PUBLIC LICENSE
*/

var socket = io();
var $myLightGauge, $myTempGauge, $myLightSysGauge, $flowRateGauge;


$('form').submit(function() {
    socket.emit('store settings', {litersPerCycle: $('#litersPerCycle').val(),
                                   pauseCycle: $('#pauseCycle').val(),
                                   lightStartHour: $('#lightStartHour').val(),
                                   lightEndHour: $('#lightEndHour').val(),
                                   lightMinimum: $('#lightMinimum').val(),
                                   airPumpConnected: $('input[name=airPumpConnected]:checked').val(),//$('#airPumpConnected').val()
                                   fanConnected: $('input[name=fanConnected]:checked').val(),//fanConnected: $('#fanConnected').val(),
                                   temperatureMax: $('#temperatureMax').val()});
    $(".procSave").show();
    return false;
});

socket.on('fetch settings', function(msg) {
    $("#litersPerCycle").val(msg.litersPerCycle);
    $(".flowCycle progress").attr("max", msg.litersPerCycle);
    $("#pauseCycle").val(msg.pauseCycle);
    $("#lightStartHour").val(msg.lightStartHour);
    $("#lightEndHour").val(msg.lightEndHour);
    $("#lightMinimum").val(msg.lightMinimum);
    $('input[name=airPumpConnected][value='+ msg.airPumpConnected +']').prop('checked', 'checked');
    $('input[name=fanConnected][value='+ msg.fanConnected +']').prop('checked', 'checked');
    $("#temperatureMax").val(msg.temperatureMax);
    $(".procSave").hide();
});

socket.on('store settings', function(msg) {
    $('#messages').prepend($('<li><span>'+msg.time+': </span>'+msg.value+'</li>'));
});

function relay(pId, pState){
    if (pState === false){
        $("#"+pId).removeClass("on");
        $("#"+pId).addClass("off");
        $("#"+pId+" span").text("OFF");
    } else if (pState === true){
        $("#"+pId).removeClass("off");
        $("#"+pId).addClass("on");
        $("#"+pId+" span").text("ON");
    }
}

socket.on('send data', function(msg){
    $myLightGauge.changeValue(msg.light);
    $myLightSysGauge.changeValue(msg.lightSys);
    $myTempGauge.changeValue(msg.temp);
    $flowRateGauge.changeValue(msg.flowRate);
    $(".flowCycle progress").val(msg.flowLiters);
    $(".flowCycle .progressTxt").text(msg.flowLiters +" / "+ $(".flowCycle progress").attr("max"));
    $("#flowTimeLast").text(getMinSec(msg.flowTimeLast));
    $("#flowTimeAvg").text(getMinSec(msg.flowTimeAvg));
    $("#flowTimeCnt").text(msg.flowTimeCnt);
    relay("relay1", msg.relay1);
    relay("relay2", msg.relay2);
    relay("relay3", msg.relay3);
    relay("relay4", msg.relay4);
    if(msg.event != ""){
        $('#events').prepend($('<li>'+msg.event+'</li>'));
    }
});

$("#soundStop").on('click', function(e){socket.emit('sound stop', 'Stop');});
$("#resetFlow").on('click', function(e){socket.emit('reset flow', 'Reset');});

function getMinSec(sec){
    var min = (sec / 60).toFixed(0);
    return min + ":"+ (sec % 60);
}